﻿using System;
using PluginInterface;
using System.Timers;
using System.Collections.Generic;

namespace vcPlugin
{
    /// <summary>
    /// Plugin2
    /// </summary>
    public class Plugin : IPlugin  // <-- See how we inherited the IPlugin interface?
    {
        //option variables
        public pluginOptions _options;
        private ctlMain mainCtl;
        
        
        public Plugin()
        {
            //
            // TODO: Add constructor logic here
            //
            _options = new pluginOptions();
        

            myMainInterface = new ctlMain(_options);
            mainCtl = (ctlMain)myMainInterface;
            

        }


        //Declarations of all our internal plugin variables
        //VoxCommando expects these to be here so don't remove them.

        #region stuff to edit for new plugins
        //Declarations of all our internal plugin variables
        //VoxCommando expects these to be here so don't remove them.
        string myName = System.Reflection.Assembly.GetExecutingAssembly().GetName().Name;
        string myDescription = 
            "My plugin for VoxCommando that does stuff.\r\nUse at your own risk!";
        
        bool myGenEvents = true;
        string myAuthor = "James Richards";
        string myVersion = System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.ToString();

        
        #endregion


        #region plugin stuff don't touch

        IPluginHost myHost = null;
        System.Windows.Forms.UserControl myMainInterface;

        public string Name
        {
            get { return myName; }
        }
        public string Description
        {
            get { return myDescription; }
        }

        public bool GenEvents
        {
            get { return myGenEvents; }
        }

        public string Author
        {
            get { return myAuthor; }
        }

        public IPluginHost Host
        {
            get
            {
                return myHost;
            }
            set
            {
                myHost = value;
                mainCtl = (ctlMain)myMainInterface;
                mainCtl.PluginHost = this.Host;
                mainCtl.Plugin = this;
            }
        }

        public string Version
        {
            get { return myVersion; }
        }

        public System.Windows.Forms.UserControl MainInterface
        {
            get { return myMainInterface; }
        }



        #endregion plugin stuff


        public void Initialize()
        {
        
            //This is the first Function called by the host...
            //Put anything needed to start with here first
            //At this point the host object exists.
            //This function is called in a thread so be careful to handle all errors.

            //e.g.    udpListener.myHost = this.Host;
        }           

        /// <summary>
        /// This is the main method called by VoxCommando when performing plugin actions.  All actions go through here.
        /// </summary>
        /// <param name="parsedActions">an array of strings parsedActions[0] is the plugin name</param>
        /// <param name="parsedParams">an array of strings representing our action parameters</param>
        /// <returns>an actionResult</returns>
        public actionResult doAction(string[] parsedActions, string[] parsedParams)
        {
            actionResult thisAR = new actionResult();

            // Putting the whole thing in a try-catch ensures we won't bring VC down even if the macro has bad action code.
            // the catch will return the error code which shows up in the VC history window
            try
            {
                //get the first action following the plugin name
                //example action:  xbmc.send  >>>   parsedActions[1] is "send"
                string actionType = parsedActions[1];


                //Do stuff based on the action                
                //   use all lowercase in case strings below

                int port = _options.numSetting1;

                switch (actionType.ToLower())
                {
                    case "dosomething":
                        //do something
                        thisAR.setInfo("here is what happened, but lastresult is not modified");
                        break;
                    case "getdata":
                        //do something
                        var myTestData = (5 * 6);
                        thisAR.setSuccess(myTestData.ToString());  //returns 30 and stores it in {LastResult}
                        break;
                    default:
                        //not a command we recognize
                        thisAR.setError("unknown " + myName + " action");
                        break;
                }
            }
            catch (Exception err)
            {
                thisAR.setError(err.ToString());
            }
            return thisAR;
        }

        #region other methods
        // put other methods here.  perhaps called by 'doAction'

        


        #endregion other methods

        public void Dispose()
        {
            //cleanup code when program is stopped 

        }

    }
}


